Skip to content

HPE Greenlake For Storage Fleet REST APIs (1.4.0)

HPE Greenlake For Storage Fleet REST APIs

Languages
Servers
https://eu1.data.cloud.hpe.com/
https://us1.data.cloud.hpe.com/
https://jp1.data.cloud.hpe.com/
Mock server
https://developer.greenlake.hpe.com/_mock/docs/greenlake/services/storage-fleet/public/openapi/storage-fleet-public-v1alpha1/storage-fleet-api/

certificates

The Certificate API provides endpoints for managing and configuring certificates.

Operations

controllers

The controllers API allows the management of controller fleet.

Operations

enclosures

The Enclosure API provides endpoints for managing and configuring enclosures.

Operations

encryption

The encryption API allows the actions on encryption.

Operations

jbofioms

The JBOF IOM API provides endpoints for managing and configuring JBOF IOMs.

Operations

migrations

The Migrations API allows the management of data migration from source storage systems.

Operations

object-notification-clients

The Object Notification Client API provides endpoints for managing and configuring object notification clients.

Operations

ports

The ports API allows the management of ports.

Operations

protection-policies

Protection policy APIs

Operations

protection-software-update-policies

Protection and Software update policy APIs

Operations

setup-blueprints

Blueprint Service API

Operations

setup-devices

Setup Orchestrator API

Operations

Returns a list of devices associated with the customer that have yet to be or have just been initialized

Request

Returns a list of devices associated with the customer that have yet to be or have just been initialized. This includes devices that are:

  • onboarded
  • uninitialized
  • initializing
  • initialized (Note that such devices will only be shown for a short period of time)
  • initialization_failed
Security
bearer
Query
offsetinteger

The number of items to skip before starting to collect the result set. Default is 20.

Example: offset=30
limitinteger(int32)<= 100

The numbers of items to return. Default is 0 which means no limit.

Default 0
Example: limit=10
filterstring

The filter query parameter is used to filter the set of resources returned in the response. The returned set of resources must match the criteria in the filter query parameter. A comparision compares a property name to a literal. The comparisons supported are the following:

  • "eq" : Is a property equal to value. Valid for number, boolean and string properties.
  • "ne" : Is a property not equal to value. Valid for number, boolean and string properties.
  • "gt" : Is a property greater than a value. Valid for number or string timestamp properties.
  • "lt" : Is a property less than a value. Valid for number or string timestamp properties.

Properties that can be filtered are:

  • name
  • blueprintId
  • description
  • model
  • associatedBlueprint.name
  • autoSetup
  • connectionStatus
  • status
  • type
  • createdAt
  • updatedAt
  • generation

Examples are:

  • GET /storage-fleet/v1alpha1/setup-devices?filter=status eq 'ONBOARDED'
  • GET /storage-fleet/v1alpha1/setup-devices?filter=updatedAt lt 2021-04-08T16:51:33Z
  • GET /storage-fleet/v1alpha1/setup-devices?filter=status eq 'ONBOARDED' and createdAt lt 2021-04-08T16:51:33Z
  • GET /storage-fleet/v1alpha1/setup-devices?filter=status ne 'UNINITIALIZED'
Example: filter=?filter=status eq 'ONBOARDED'
selectstring

A list of properties to include in the response.

Example: select=?select=id,status
sortstring

Instruct the server to sort the resources returned with a collection-level GET. They provide sorting by one or more properties in ascending or descending order. Each item in the “sort” query parameter is a property name optionally followed by a direction indicator. The direction indicator may only be either “asc” (ascending) or “desc” (descending). If no direction indicator is specified, the default order is ascending. The first item in the “sort” query parameter defines the primary sort order, the second defines the secondary sort order, the third defines the tertiary sort order, etc.

Properties that can be sorted are:

  • name
  • blueprintId
  • id
  • serialNumber
  • name
  • description
  • model
  • type
  • connectionStatus
  • associatedBlueprint.name
  • status
  • autoSetup
  • createdAt
  • updatedAt
  • generation
Example: sort=?sort=createdAt desc
curl -i -X GET \
  https://eu1.data.cloud.hpe.com/storage-fleet/v1alpha1/setup-devices \
  -H 'Authorization: Bearer <YOUR_JWT_HERE>'

Responses

Devices list

Bodyapplication/json
itemsArray of objects(System)required
items[].​idstring(uuid)read-onlyrequired

An identifier for the resource, usually a UUID.

items[].​typestringread-onlyrequired

The type of resource.

items[].​generationinteger(int64)read-onlyrequired

A monotonically increasing value. This value updates when the resource is updated and can be used as a short way to determine if a resource has changed or which of two different copies of a resource is more up to date.

items[].​createdAtstring(date-time)read-onlyrequired

The time this device was registered

items[].​updatedAtstring(date-time)read-onlyrequired

The time this device was last updated

items[].​resourceUristringread-onlyrequired

The self reference for this resource.

items[].​customerIdstringread-onlyrequired

The customer application identifier

items[].​namestring

A system specified name for the resource.

items[].​associatedBlueprintobject
items[].​associatedSetupTaskobject
items[].​autoSetupboolean

If true, then once a device connects to the Data Services Cloud Console, it will be initialized automatically with the associated blueprint. If false, then user will have to manually initiate the device initialization at some point after the device has connected to the Cloud Console. Default is false.

Default false
items[].​blueprintIdstring

uuid of the blueprint associated with this device. If empty, then there is no blueprint associated with this device.

items[].​connectionStatusstringread-only

Whether the device is connected to the Data Services Cloud Console

Enum"CONNECTED""NOT_CONNECTED"
items[].​contactstring

Contact information for this device

items[].​descriptionstring

Description of the device

items[].​hardwareInformationobjectread-only
items[].​initCompleteTimestring(date-time)read-only

The time this device completed initialization either successfully or unsuccessfully.

items[].​modelstringread-only

Model family of the device

Enum"ALLETRA_5000""ALLETRA_6000""ALLETRA_9000"
items[].​modelNumberstringread-only

Model number of the device, for example "6030"

Example: "6030"
items[].​numberOfAttemptsintegerread-only

Number of setup attempts.

items[].​osVersionstringread-only

Software version running on the device.

items[].​overrideobject
items[].​preConfiguredDataobject
items[].​serialNumberstringread-only

Serial number of the device

items[].​statusstring(StatusType)read-only
Enum"ONBOARDED""UNINITIALIZED""INITIALIZING"
items[].​tunnelSetupUserAgentstringread-only

Name of the on-premise agent that was used by the user when establishing tunnel from the device to Data Services Cloud Console.

Example: "Mozilla/5.0"
pageOffsetintegerread-onlyrequired

The offset query parameter specified in the request.

Default 0
pageLimitintegerread-onlyrequired

The limit query parameter specified in the request.

Default 20
totalintegerread-onlyrequired

Total number of devices in the collection

countintegerread-onlyrequired

Number of devices in this response

Response
application/json
{ "count": 0, "items": [ { … } ], "pageLimit": 20, "pageOffset": 0, "total": 0 }

Returns a specific device associated with the customer that have yet to be or have just been initialized

Request

Get a specific device

Security
bearer
Path
idstring(uuid)required

The UUID of the object

Example: c1a0eb78-41a0-4151-93b2-f057ffeca3f3
Query
selectstring

A list of properties to include in the response.

Example: select=select=id,status
curl -i -X GET \
  https://eu1.data.cloud.hpe.com/storage-fleet/v1alpha1/setup-devices/c1a0eb78-41a0-4151-93b2-f057ffeca3f3 \
  -H 'Authorization: Bearer <YOUR_JWT_HERE>'

Responses

Single device

Bodyapplication/json
idstring(uuid)read-onlyrequired

An identifier for the resource, usually a UUID.

typestringread-onlyrequired

The type of resource.

generationinteger(int64)read-onlyrequired

A monotonically increasing value. This value updates when the resource is updated and can be used as a short way to determine if a resource has changed or which of two different copies of a resource is more up to date.

createdAtstring(date-time)read-onlyrequired

The time this device was registered

updatedAtstring(date-time)read-onlyrequired

The time this device was last updated

resourceUristringread-onlyrequired

The self reference for this resource.

customerIdstringread-onlyrequired

The customer application identifier

namestring

A system specified name for the resource.

associatedBlueprintobject
associatedSetupTaskobject
autoSetupboolean

If true, then once a device connects to the Data Services Cloud Console, it will be initialized automatically with the associated blueprint. If false, then user will have to manually initiate the device initialization at some point after the device has connected to the Cloud Console. Default is false.

Default false
blueprintIdstring

uuid of the blueprint associated with this device. If empty, then there is no blueprint associated with this device.

connectionStatusstringread-only

Whether the device is connected to the Data Services Cloud Console

Enum"CONNECTED""NOT_CONNECTED"
contactstring

Contact information for this device

descriptionstring

Description of the device

hardwareInformationobjectread-only
initCompleteTimestring(date-time)read-only

The time this device completed initialization either successfully or unsuccessfully.

modelstringread-only

Model family of the device

Enum"ALLETRA_5000""ALLETRA_6000""ALLETRA_9000"
modelNumberstringread-only

Model number of the device, for example "6030"

Example: "6030"
numberOfAttemptsintegerread-only

Number of setup attempts.

osVersionstringread-only

Software version running on the device.

overrideobject
preConfiguredDataobject
serialNumberstringread-only

Serial number of the device

statusstring(StatusType)read-only
Enum"ONBOARDED""UNINITIALIZED""INITIALIZING"
tunnelSetupUserAgentstringread-only

Name of the on-premise agent that was used by the user when establishing tunnel from the device to Data Services Cloud Console.

Example: "Mozilla/5.0"
Response
application/json
{ "createdAt": "2019-08-24T14:15:22Z", "customerId": "string", "generation": 0, "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08", "name": "string", "resourceUri": "string", "type": "string", "updatedAt": "2019-08-24T14:15:22Z", "associatedBlueprint": { "name": "string", "resourceUri": "string", "type": "string", "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08" }, "associatedSetupTask": { "name": "string", "resourceUri": "string", "type": "string", "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08" }, "autoSetup": false, "blueprintId": "string", "connectionStatus": "CONNECTED", "contact": "string", "description": "string", "hardwareInformation": { "components": { … }, "dscId": "string", "fcPorts": [ … ], "inventory": { … }, "iscsiPorts": [ … ], "networkInterfaces": [ … ], "personaInfo": "kvm-alletramp-dhci" }, "initCompleteTime": "2019-08-24T14:15:22Z", "model": "ALLETRA_5000", "modelNumber": "6030", "numberOfAttempts": 0, "osVersion": "string", "override": { "autoSupport": { … }, "autoUpdateOs": true, "cluster": { … }, "dataNetwork": [ … ], "dateTime": { … }, "dnsConfig": { … }, "forceRollback": true, "isHpeEulaAccepted": true, "isVmwareEulaAccepted": true, "mgmtNetwork": { … }, "proxyConfig": { … }, "s3FrontEndConfiguration": { … }, "serverSetups": { … }, "supportContact": { … }, "switchAdminCredentialId": "string", "systemIdentity": { … }, "userCreds": { … }, "vcenter": { … }, "vdsManagementOnly": true, "vdsSelected": true, "virtualization": { … } }, "preConfiguredData": { "dateTime": { … }, "dnsConfig": { … }, "manufacturingData": { … }, "mgmtNetwork": { … }, "proxyConfig": { … }, "serverSetups": { … }, "systemIdentity": { … } }, "serialNumber": "string", "status": "ONBOARDED", "tunnelSetupUserAgent": "Mozilla/5.0" }

Update override properties of a device, including kickstarting a setup

Request

Update override properties of a device

Security
bearer
Path
idstring(uuid)required

The UUID of the object

Example: c1a0eb78-41a0-4151-93b2-f057ffeca3f3
Bodyapplication/merge-patch+jsonrequired
autoSetupboolean

If true, then once a device connects to the Data Services Cloud Console, it will be initialized automatically with the associated blueprint. If false, then user will have to manually initiate the device initialization at some point after the device has connected to the Cloud Console. Default is false.

Default false
blueprintIdstring(uuid)

uuid of the blueprint to change to. Set this to empty string to remove the blueprint.

contactstring

Contact information for this device

descriptionstring

Description of the device

generationinteger(int64)

The current generation number of the device

overrideobject
curl -i -X PATCH \
  https://eu1.data.cloud.hpe.com/storage-fleet/v1alpha1/setup-devices/c1a0eb78-41a0-4151-93b2-f057ffeca3f3 \
  -H 'Authorization: Bearer <YOUR_JWT_HERE>' \
  -H 'Content-Type: application/merge-patch+json' \
  -d '{}'

Responses

Updated device

Headers
Locationstring

The uri of the created resource

Bodyapplication/json
idstring(uuid)read-onlyrequired

An identifier for the resource, usually a UUID.

typestringread-onlyrequired

The type of resource.

generationinteger(int64)read-onlyrequired

A monotonically increasing value. This value updates when the resource is updated and can be used as a short way to determine if a resource has changed or which of two different copies of a resource is more up to date.

createdAtstring(date-time)read-onlyrequired

The time this device was registered

updatedAtstring(date-time)read-onlyrequired

The time this device was last updated

resourceUristringread-onlyrequired

The self reference for this resource.

customerIdstringread-onlyrequired

The customer application identifier

namestring

A system specified name for the resource.

associatedBlueprintobject
associatedSetupTaskobject
autoSetupboolean

If true, then once a device connects to the Data Services Cloud Console, it will be initialized automatically with the associated blueprint. If false, then user will have to manually initiate the device initialization at some point after the device has connected to the Cloud Console. Default is false.

Default false
blueprintIdstring

uuid of the blueprint associated with this device. If empty, then there is no blueprint associated with this device.

connectionStatusstringread-only

Whether the device is connected to the Data Services Cloud Console

Enum"CONNECTED""NOT_CONNECTED"
contactstring

Contact information for this device

descriptionstring

Description of the device

hardwareInformationobjectread-only
initCompleteTimestring(date-time)read-only

The time this device completed initialization either successfully or unsuccessfully.

modelstringread-only

Model family of the device

Enum"ALLETRA_5000""ALLETRA_6000""ALLETRA_9000"
modelNumberstringread-only

Model number of the device, for example "6030"

Example: "6030"
numberOfAttemptsintegerread-only

Number of setup attempts.

osVersionstringread-only

Software version running on the device.

overrideobject
preConfiguredDataobject
serialNumberstringread-only

Serial number of the device

statusstring(StatusType)read-only
Enum"ONBOARDED""UNINITIALIZED""INITIALIZING"
tunnelSetupUserAgentstringread-only

Name of the on-premise agent that was used by the user when establishing tunnel from the device to Data Services Cloud Console.

Example: "Mozilla/5.0"
Response
application/json
{ "createdAt": "2019-08-24T14:15:22Z", "customerId": "string", "generation": 0, "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08", "name": "string", "resourceUri": "string", "type": "string", "updatedAt": "2019-08-24T14:15:22Z", "associatedBlueprint": { "name": "string", "resourceUri": "string", "type": "string", "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08" }, "associatedSetupTask": { "name": "string", "resourceUri": "string", "type": "string", "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08" }, "autoSetup": false, "blueprintId": "string", "connectionStatus": "CONNECTED", "contact": "string", "description": "string", "hardwareInformation": { "components": { … }, "dscId": "string", "fcPorts": [ … ], "inventory": { … }, "iscsiPorts": [ … ], "networkInterfaces": [ … ], "personaInfo": "kvm-alletramp-dhci" }, "initCompleteTime": "2019-08-24T14:15:22Z", "model": "ALLETRA_5000", "modelNumber": "6030", "numberOfAttempts": 0, "osVersion": "string", "override": { "autoSupport": { … }, "autoUpdateOs": true, "cluster": { … }, "dataNetwork": [ … ], "dateTime": { … }, "dnsConfig": { … }, "forceRollback": true, "isHpeEulaAccepted": true, "isVmwareEulaAccepted": true, "mgmtNetwork": { … }, "proxyConfig": { … }, "s3FrontEndConfiguration": { … }, "serverSetups": { … }, "supportContact": { … }, "switchAdminCredentialId": "string", "systemIdentity": { … }, "userCreds": { … }, "vcenter": { … }, "vdsManagementOnly": true, "vdsSelected": true, "virtualization": { … } }, "preConfiguredData": { "dateTime": { … }, "dnsConfig": { … }, "manufacturingData": { … }, "mgmtNetwork": { … }, "proxyConfig": { … }, "serverSetups": { … }, "systemIdentity": { … } }, "serialNumber": "string", "status": "ONBOARDED", "tunnelSetupUserAgent": "Mozilla/5.0" }

Retry setup on a device. Applies only to PC3000 with HPE Alletra 5000 and HPE Alletra 6000 systems.

Request

Retry setup on a device. Applies only to PC3000 with HPE Alletra 5000 and HPE Alletra 6000 systems.

Security
bearer
Path
idstring(uuid)required

The UUID of the object

Example: c1a0eb78-41a0-4151-93b2-f057ffeca3f3
curl -i -X POST \
  https://eu1.data.cloud.hpe.com/storage-fleet/v1alpha1/setup-devices/c1a0eb78-41a0-4151-93b2-f057ffeca3f3/retry-setup \
  -H 'Authorization: Bearer <YOUR_JWT_HERE>'

Responses

List of affected devices

Headers
Locationstring

The uri of the created resource

Bodyapplication/json
typestringread-onlyrequired
resourceUristringread-onlyrequired
namestringread-only
Response
application/json
{ "name": "string", "resourceUri": "string", "type": "string" }

Get the specific setup progress for a device

Request

Get the specific setup progress for a device

Security
bearer
Path
idstring(uuid)required

The UUID of the object

Example: c1a0eb78-41a0-4151-93b2-f057ffeca3f3
Query
selectstring

A list of properties to include in the response.

Example: select=select=id,status
curl -i -X GET \
  https://eu1.data.cloud.hpe.com/storage-fleet/v1alpha1/setup-progress/c1a0eb78-41a0-4151-93b2-f057ffeca3f3 \
  -H 'Authorization: Bearer <YOUR_JWT_HERE>'

Responses

Single device

Bodyapplication/json
idstring(uuid)read-onlyrequired

An identifier for the resource, usually a UUID.

typestringread-onlyrequired

The type of resource.

generationinteger(int64)read-onlyrequired

A monotonically increasing value. This value updates when the resource is updated and can be used as a short way to determine if a resource has changed or which of two different copies of a resource is more up to date.

createdAtstring(date-time)required
updatedAtstring(date-time)required
resourceUristringread-onlyrequired

The self reference for this resource.

customerIdstringread-onlyrequired

The customer application identifier

namestring

A system specified name for the resource.

initializationStepsArray of objects(InitializationStepProperties)read-only

The steps of the device initialization process

Example: [{"percentComplete":5,"state":"RUNNING","stepId":"NIMBLE_SETUP","stepName":"Setting up Nimble","subSteps":[{"percentComplete":10,"state":"RUNNING","stepId":"INITIAL_SETUP","stepName":"Setting up management interface and administrator credentials..."},{"percentComplete":5,"state":"PENDING","stepId":"CHECK_INITIAL_SETUP","stepName":"Running sanity checks before continuing..."}]}]
setupProgressPercentinteger(Uint32)[ 0 .. 100 ]read-only

Overall percent completion of the device initialization.

Example: 1
statestringread-only

The overall state of the system initialization process

Enum"PENDING""RUNNING""COMPLETED"
Response
application/json
{ "createdAt": "2019-08-24T14:15:22Z", "customerId": "string", "generation": 0, "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08", "name": "string", "resourceUri": "string", "type": "string", "updatedAt": "2019-08-24T14:15:22Z", "initializationSteps": [ { … } ], "setupProgressPercent": 1, "state": "PENDING" }

shelves

The shelves API allows the management of shelves.

Operations

storage-nodes

The Storage Node API provides endpoints for managing and configuring storage nodes.

Operations

storage-systems

The storage-systems API allows management of storage devices.

Operations

switches

The Switch API provides endpoints for managing and configuring switches.

Operations

system-settings

The system settings API allows the monitoring of system settings for the device.

Operations

filesystems

Operations

vvolscs

Operations